import java.util.*;
import java.io.*;
import org.chocosolver.solver.Model;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.util.tools.ArrayUtils;

public class MSP {

    int[][] distance; // travel distance between meetings
    int[][] attends;  // attends[i][j] = 1 <-> agent_i is at meeting_j
    IntVar span;
    int n,m,timeSlots;
    Model model;
    Solver solver;
    int[] solution;
    boolean verbose;
    //
    // declare your constrained integer variables here
    //

    public MSP(int n, int m, int timeSlots, int[][] distance, int[][] attends){
	solution       = new int[n];
	model          = new Model("MSP");
	solver         = model.getSolver();
	this.n         = n;
	this.m         = m;
	this.timeSlots = timeSlots;
	this.attends   = attends;

	//
	// make your constrained integer variables here
	//

	//
	// post your constraints here
	//

	//
	// maybe use a variable and value ordering heuristic
	//
    }

    void optimize(){
	//
	// model.setObjective(Model.MINIMIZE,???);
	//
	while (solver.solve())
	    for (int i=0;i<n;i++){
		//solution[i] = ???
	    }
    }

    void solve(){
	if (solver.solve())
	    for (int i=0;i<n;i++){
		//solution[i] = ???
	    }
    }

    void show(){
	if (verbose)
	    for (int i=0;i<n;i++)
		System.out.println(i +" "+ solution[i]);
	solver.printShortStatistics();
    }
}
